gosub Init
while 1
  gosub RoamAndObserve
  xyString 10,3,"MemSize = ",NumStates," "
  b=LastButton()
  if b="THIN"
    S1=3
    S2=3
    S3=3
    gosub DrawLine
  elseif b="MEDIUM"
    S1=6
    S2=6
    S3=6
    gosub DrawLine
  elseif b="THICK"
    S1=10 
    S2=10
    S3=10
    gosub DrawLine
  elseif b="MIXED"
    S1=3
    S2=6
    S3=10
    gosub DrawLine
  elseif b="FORGET EASILY"
    ConfLevel = 2
    for i=0 to NumStates-1
      if ConfidenceLevel[i]>=2 then ConfidenceLevel[i]=2
    next 
  elseif b="REMEMBER LONGER"
    ConfLevel = 5
    for i=0 to NumStates-1
      if ConfidenceLevel[i]>=1 then ConfidenceLevel[i]=5
    next
  elseif b="REMOVE VISION"
    Rand = 3
    NumStates = 0
  elseif b="ADD VISION"  
    Rand = 1
    NumStates = 0
  elseif b="VIEW MEM."
    ClearScr
    Print
    Print
    Print "STATE ACTION CONFIDENCE               STATE  ACTION  CONFIDENCE"
    Print "----- ------ ----------               -----  ------  ----------"
    for i=0 to NumStates-1 step 2
      print "  ",GoodState[i];""; ActionToTake[i];ConfidenceLevel[i];"        "; \
            GoodState[i+1]; ActionToTake[i+1];ConfidenceLevel[i+1]
    next
    print \ print\ print
    print "               Click the screen to RESUME"
    repeat
      ReadMouse mx,my,mb
    until mb
    gosub DrawLine
  endif
wend

Init:
  ScrSetMetrics ,,,,0
  rLocate 400,300,Random(100)
  rSenseType 5
  rInvisible Green
  // Definition of Memory
  Dim GoodState[50]
  // states that can provide reward
  Dim ActionToTake[50]
  // values of 1 to 5
  Dim ConfidenceLevel[50]
  // max Confidence of 5, remove when 0
  for i=0 to 49
    GoodState[i]=0
    ActionToTake[i]=0
    ConfidenceLevel[i]=0
  next
  ConfLevel = 2
  NumStates = 0
  Rand = 3
  AddButton "THIN",131,2,44,20
  AddButton "MEDIUM",175,2,65,20
  AddButton "THICK",240,2,50,20
  AddButton "MIXED",290,2,50,20
  AddButton "VIEW MEM.",340,2,80,20
  AddButton "FORGET",420,2,65,20
  AddButton "REMEMBER",485,2,90,20
  AddButton "ADD VISION",575,2,100,20
  AddButton "REMOVE VISION",675,2,124,20
  S1=6
  S2=6
  S3=6
  gosub DrawLine
return

DrawLine:
  rx=rGPSx()
  ry=rGPSy()
  rd=rCompass()
  rLocate 750,650
  ClearScr
  Line 2,21,130,21,2,Black
  Line 2,1,800,1,2,Black
  Line 2,1,2,21,2,Black
  Line 130,1,130,21,2,Black
  SetColor Green
  LineWidth S1
  Line 150,200,200,150
  LineTo 300,125
  LineTo 400,150,S2
  LineTo 500,150,S2
  LineTo 600,200,S3
  LineTo 650,250,S3
  LineTo 650,300,S2
  LineTo 625,350,S2
  LineTo 625,400,S3
  LineTo 650,450,S3
  LineTo 600,500,S3
  LineTo 500,530,S2
  LineTo 400,500
  LineTo 300,500
  Line 270,500,200,475
  LineTo 175,475
  LineTo 150,450
  LineTo 120,400,S2
  LineTo 100,300,S2
  Line 80,250,150,200,S2
  Line 100,80,200,100
  LineTo 300,80
  LineTo 400,100
  Line 600,50,650,100,S2
  LineTo 700,200,S2
  LineTo 710,300,S2
  LineTo 750,400,S2
  LineTo 700,500,S2
  Line 50,400,100,500,S3
  LineTo 150,550,S3
  LineTo 200,550,S3
  LineTo 250,570,S3
  Line 300,300,400,370,S2
  LineTo 500,320,S2
  LineTo 580,400,S2
  Line 200,300,260,300,S3
  LineTo 300,250,S3
  LineTo 350,240,S3
  Line 400,250,500,250,S1
  LineTo 540,280,S1
  LineTo 600,270
  Line 250,450,300,450,S1
  LineTo 350,430,S1
  LineTo 400,450,S1
  LineTo 500,410,S1
  LineTo 550,450,S1
  rLocate rx,ry,rd
  rSenseType 5
  rInvisible Green
return



RoamAndObserve:
  // genetically turn away from walls
  if rFeel() then rTurn (90+Random(90))
  if rSense()
    // something got our attention
    gosub ReactAndAnalyze
  else
    if !rFeel() then rForward 1
  endif
return

ReactAndAnalyze:
  CurState = rSense()
   // see if CurState is in memory
  InMemory=false
  if NumStates>0
    for p=0 to NumStates-1
      if GoodState[p]=CurState
        InMemory = True
        break
      endif
    next
  endif
  if InMemory
    // react as expected based on past experience
    gosub "Action"+ActionToTake[p] // do the action associated with the state
    // decide if the action still produces good outcome
    NewState = rSense()
    Reward=false
    if NewState&2 then Reward=True
    // Also reward if this NewState is in memory
    if !Reward and NumStates>0       
      for i=0 to NumStates-1
        if NewState=GoodState[i] 
          Reward=True
          break
        endif
      next
    endif       
    if !Reward  
      // old memory does not seem to be valid
      ConfidenceLevel[p]--
      if ConfidenceLevel[p]=0
        for i=p to NumStates-1  // delete memory
          GoodState[i]=GoodState[i+1]
          ActionToTake[i]=ActionToTake[i+1]
          ConfidenceLevel[i]=ConfidenceLevel[i+1]
        next
        NumStates--
      endif  
    else
      // increase confidence of memory (up to 2)
      if ConfidenceLevel[p]<ConfLevel then ConfidenceLevel[p]++
    endif   
  else
    // try something new
    NewAction =  Random(6)+Rand
    gosub "Action"+NewAction
    // now see if the New Action produced good results
    NewState = rSense()
    Reward=false
    if NewState&2 then Reward=True  // gave direct reward
    // Also reward if this NewState is in memory
    if !Reward and NumStates>0
      for i=0 to NumStates-1
        if NewState=GoodState[i] 
          Reward=True
          break
        endif
      next 
    endif
    if Reward
      // good result so add to memory if not there already
      // CurState is what initiated this action so add to memory
      // NewAction is what we did to get rewarding results
      GoodState[NumStates]=CurState
      ActionToTake[NumStates]=NewAction
      ConfidenceLevel[NumStates]=1
      NumStates++
    endif 
  endif  
return



Action3: // easy left
  rForward 1
  rTurn -1
return

Action4: // easy right
  rForward 1
  rTurn 1
return

Action5: // medium left
  rForward 1
  rTurn -3
return

Action6: // medium right
  rForward 1
  rTurn 3
return

Action7: // Hard left
  rForward 1
  rTurn -6
return

Action8: // Hard right
  rForward 1
  rTurn 6
return

Action1: // hard left
  for i=1 to 10
    rForward 1
    if rFeel()then break
  next
  for i=1 to 70
    rTurn -1
    if rSense() then break
  next
return

Action2: // hard right
  for i=1 to 10
    rForward 1
    if rFeel()then break
  next
  for i=1 to 70
    rTurn 1
    if rSense() then break
  next
return

  
